import 'package:flutter/material.dart';
import 'package:path_stack/path_stack.dart';

import 'simple_tab_example.dart';

/// Just a basic tabbed scaffold
class TabScaffold extends StatelessWidget {
  const TabScaffold(this.selectedTab, {Key? key, required this.child, required this.onTabPressed}) : super(key: key);
  final Widget child;
  final PageType selectedTab;
  final void Function(PageType value) onTabPressed;

  @override
  Widget build(BuildContext context) {
    TextStyle textStyle = TextStyle(fontSize: 32);
    return Column(
      children: [
        Expanded(child: child),
        Row(children: [
          Expanded(
              child: TextButton(onPressed: () => onTabPressed(PageType.Home), child: Text("Home", style: textStyle))),
          Expanded(
              child: TextButton(
                  onPressed: () => onTabPressed(PageType.Settings), child: Text("Settings", style: textStyle))),
          Expanded(
              child: TextButton(
                  onPressed: () => onTabPressed(PageType.Explore), child: Text("Explore", style: textStyle))),
        ]),
      ],
    );
  }
}

/// Example pages
class HomePage extends StatefulWidget {
  @override
  _HomePageState createState() => _HomePageState();
}

class _HomePageState extends State<HomePage> {
  int buildCount = 0;
  @override
  Widget build(BuildContext context) {
    return Center(child: Text("Home, buildCount=${buildCount++}", style: TextStyle(fontSize: 42)));
  }
}

class SettingsPage extends StatefulWidget {
  @override
  _SettingsPageState createState() => _SettingsPageState();
}

class _SettingsPageState extends State<SettingsPage> {
  int buildCount = 0;
  @override
  Widget build(BuildContext context) {
    return Center(child: Text("Settings, buildCount=${buildCount++}", style: TextStyle(fontSize: 42)));
  }
}

class ExplorePage extends StatefulWidget {
  @override
  _ExplorePageState createState() => _ExplorePageState();
}

class _ExplorePageState extends State<ExplorePage> {
  int buildCount = 0;

  @override
  Widget build(BuildContext context) {
    return Center(child: Text("Explore, buildCount=${buildCount++}", style: TextStyle(fontSize: 42)));
  }
}
